import { ContextValue, Dict, ScriptContext, SyntaxNode } from '../common';
export declare const getKeysOf: (dict: Dict, referrer: SyntaxNode, context: ScriptContext) => ContextValue[];
export declare const hasProperty: (dict: Dict, key: ContextValue, keyReferrer: SyntaxNode, operationReferrer: SyntaxNode, context: ScriptContext) => ContextValue;
export declare const removeProperty: (target: ContextValue, key: ContextValue, keyReferrer: SyntaxNode, operationReferrer: SyntaxNode, context: ScriptContext) => void;
export declare const getProperty: (target: ContextValue, key: ContextValue, allowMagic: boolean, keyReferrer: SyntaxNode, operationReferrer: SyntaxNode, context: ScriptContext) => ContextValue;
export declare const setProperty: (target: ContextValue, key: ContextValue, value: ContextValue, allowMagic: boolean, keyReferrer: SyntaxNode, operationReferrer: SyntaxNode, context: ScriptContext) => void;
export declare const createClass: (description: Dict, referrer: SyntaxNode | null, context: ScriptContext | null) => Dict;
export declare const getConstructorOf: (dict: Dict) => ContextValue;
export declare const isInstanceOf: (constructor: ContextValue, dict: Dict) => boolean;
export declare const wrapPromise: (builtinPromise: Dict, promise: Promise<ContextValue>, referrer: SyntaxNode, context: ScriptContext) => Dict;
