import { ContextValue, SyntaxNode, ScriptContext } from '../common';
import { CompiledExpression } from '../eval/evalExpression';
export declare type FunctionCallback = (args: ContextValue[], referrer: SyntaxNode, context: ScriptContext, thisArg: ContextValue) => ContextValue;
export interface ArgDefinition {
    name: string;
    required: boolean;
    rest: boolean;
    default: CompiledExpression | null;
}
export interface ArgList {
    args: ArgDefinition[];
    requiredCount: number;
    restArg: string | null;
}
/**
 * Parse single argument declaration.
 */
export declare const parseArg: (rawArgs: readonly SyntaxNode[], begin: number, end: number, context: ScriptContext, allowRequired: boolean) => ArgDefinition;
/**
 * Parse argument list.
 */
export declare const parseArgList: (rawArgList: readonly SyntaxNode[], context: ScriptContext) => ArgList;
export declare const isInvocable: (target: ContextValue) => boolean;
export declare const invoke: (target: ContextValue, rawArgs: readonly SyntaxNode[], referrer: SyntaxNode, context: ScriptContext, thisArg: ContextValue) => ContextValue;
